            ;************************************
            ;   SOFTWARE FOR  ET-8032  VER 2.0  *
            ;       PROGRAM TEST DAC0832        *
            ;  ANALOG  OUTPUT OF ET-ADIO BOARD  *
            ;************************************

            ORG 8000H
IC_DAC      EQU 0E048H
DSP         EQU 9F00H             ; buffer display (7 seg.)
BUF         EQU 9F07H             ; buffer display (BCD)
HEXBUF      EQU 22H               ; data (HEX) buffer
DECBUF      EQU 23H               ; data (DEC) buffer
KEYBUF      EQU 25H               ; key buffer (7 seg.)


            ;********************
            ;*   MAIN PROGRAM   *
            ;********************

START:      MOV    HEXBUF,#00H    ; initial first display
            MOV    DECBUF,#00H
SETUP:      MOV    DPTR,#BUF+1
            MOV    A,DECBUF
            MOVX   @DPTR,A        ; input HEX
            MOV    DPTR,#BUF+2
            MOV    A,HEXBUF
            MOVX   @DPTR,A        ; input DEC
            MOV    A,#32H         ; call "UNPACK"
            LCALL  0030H          ; BUF -> DSP
            MOV    DPTR,#DSP+0
            MOVX   A,@DPTR
            ORL    A,#80H         ; set dot
            MOVX   @DPTR,A
            MOV    DPTR,#DSP+2    ; off DSP
            MOV    A,#00H
            MOVX   @DPTR,A
            MOV    DPTR,#DSP+3
            MOVX   @DPTR,A
SCANKEY:    MOV    A,#25H         ; call "SCAND"
            LCALL  0030H          ; scan DSP & KEY
            CJNE   A,#13H,CHECK1  ; check Enter key
            LCALL  BEEP
            AJMP   ENDSCAN        ; if Enter -> ENDSCAND
CHECK1:     CJNE   A,#0AH,CHECK2  ; check 0-9 only
            AJMP   SCANKEY
CHECK2:     JNC    SCANKEY        ; over 9 -> SCANKEY
            LCALL  GET2           ; check 2 input
            LCALL  BEEP
            LCALL  DELAY
            AJMP   SCANKEY
ENDSCAN:    MOV    DPTR,#DSP+0
            MOVX   A,@DPTR
            ANL    A,#7FH         ; clear dot
            MOV    A,#28H         ; call "SCANPACK"
            LCALL  0030H          ; DSP -> BUF
            MOV    DPTR,#BUF+1
            MOVX   A,@DPTR
            CJNE   A,#51H,CHECK3
CHECK3:     JNC    SETUP
            MOV    R2,A
            MOV    DECBUF,A       ; save data display
            MOV    A,#05H         ; call "BCD_HEXS"
            LCALL  0030H          ; DEC -> HEX
            MOV    DPTR,#OUTTAB
            MOV    A,R2
            ADD    A,DPL
            MOV    DPL,A
            MOVX   A,@DPTR        ; data out
            MOV    HEXBUF,A       ; save data out
            MOV    DPTR,#IC_DAC   ; out port DAC0832
            MOVX   @DPTR,A
            LCALL  DELAY
            LJMP   SETUP





            ;************************
            ;*** GET 2-DIGIT SUB. ***
            ;************************

GET2:       MOV    DPTR,#SEGTAB   ; address table
            ADD    A,DPL          ; low byte + key code
            MOV    DPL,A          ; keep low byte address
            CLR    A
            ADDC   A,DPH
            MOV    DPH,A          ; keep high byte address
            MOVX   A,@DPTR        ; 7 code of key
            MOV    KEYBUF,A       ; save 7 code of key
DIGIT2:     MOV    DPTR,#DSP+1    ; point to digit 2
            MOVX   A,@DPTR
            CJNE   A,#00H,DIGIT1
            MOV    A,KEYBUF
            MOVX   @DPTR,A        ; write digit 2
            AJMP   ENDGET
DIGIT1:     MOV    A,#09H         ; DEC DPTR
            LCALL  0030H          ; point to digit 1
            MOV    A,KEYBUF
            ORL    A,#80H         ; set dot display
            MOVX   @DPTR,A        ; write digit 1
            INC    DPTR
            MOV    A,#00H
            MOVX   @DPTR,A
ENDGET:     RET

BEEP:       MOV    A,#18H         ; call "HI_BEEP"
            LCALL  0030H
            RET

DELAY:      MOV    R2,#00H
DELAY1:     MOV    R3,#00H
DELAY2:     DJNZ   R3,DELAY2
            DJNZ   R2,DELAY1
            RET

SEGTAB:     DB     3FH,06H,5BH,4FH,66H   ; 0 1 2 3 4
            DB     6DH,7DH,07H,7FH,6FH   ; 5 6 7 8 9

OUTTAB:     DB  000H,005H,00AH,00FH,014H
            DB  019H,01FH,024H,029H,02EH
            DB  033H,038H,03DH,042H,047H
            DB  04DH,052H,057H,05CH,061H
            DB  066H,06BH,070H,075H,07AH
            DB  07FH,085H,08AH,08FH,094H
            DB  099H,09EH,0A3H,0A8H,0AEH
            DB  0B3H,0B8H,0BDH,0C2H,0C7H
            DB  0CCH,0D1H,0D6H,0DBH,0E1H
            DB  0E6H,0EBH,0F0H,0F5H,0FAH
            DB  0FFH

            END
